// main part -- custom
// $Id: factory.cpp,v 1.9 2001/10/10 07:03:19 ar Exp $
// 
/* Copyright (C) 2001 ATRSoft GmbH 
   This file is part of the ATRSoft GmbH utilitys.

   The ATRSoft GmbH utilitys is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or any later version.

   The ATRSoft GmbH utilitys is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the ATRSoft GmbH utilitys; see the file LICENSE.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

// http://www.atrsoft.de
// mailto: info@atrsoft.de

// visual c++ mfc add on. we dont need this if no afx app....
// for mfc apps you have to remove the double slashs 
// #include <stdafx.h>

// impls of visited classes which are derived from docelement are instantiated here
// so we need the accept methods of the acceptors here

#ifndef INCLUDED_FACTORY_H
#    include "factory.h"
#    undef INCLUDED_FACTORY_H
#    define INCLUDED_FACTORY_H
#endif

// we need the visitor base classe here
#ifndef INCLUDED_VOIDVISITORBASE_H
#    include "voidvisitorbase.h"
#    undef INCLUDED_VOIDVISITORBASE_H
#    define INCLUDED_VOIDVISITORBASE_H
#endif

// the derived classes....
#ifndef INCLUDED_WORD_H
#    include "word.h"
#    undef INCLUDED_WORD_H
#    define INCLUDED_WORD_H
#endif

#ifndef INCLUDED_PARAGRAPH_H
#    include "paragraph.h"
#    undef INCLUDED_PARAGRAPH_H
#    define INCLUDED_PARAGRAPH_H
#endif

#ifndef INCLUDED_GRAPHIC_H
#    include "graphic.h"
#    undef INCLUDED_GRAPHIC_H
#    define INCLUDED_GRAPHIC_H
#endif

// lib stuff ....
#ifndef INCLUDED_CSTRING
#    include <cstring>
#    undef INCLUDED_CSTRING
#    define INCLUDED_CSTRING
#endif

#ifndef INCLUDED_IOSTREAM
#    include <iostream>
#    undef INCLUDED_IOSTREAM
#    define INCLUDED_IOSTREAM
#endif

// if your compiler cannot handle the accept method by itself you
// have to help it with the explicit explicit instanciated accept methods
ATRSOFTLINIE18ACCEPTOR(Word,DocElement,VoidVisitor)

ATRSOFTLINIE18ACCEPTOR(Paragraph,DocElement,VoidVisitor)

ATRSOFTLINIE18ACCEPTOR(Graphic,DocElement,VoidVisitor)

// ok. now the factory ....
// should use plugins here, but I m soo lazy ....
DocElement*
DocElementFactory (const char* i_elementname)
{
    using namespace std;
    
    cerr << "sizeof Word " << sizeof (Word) << endl
	      << "Inheritancemode Word " << sizeof (Word::InheritanceMode) << endl;

    if (strcmp (i_elementname, "Word") == 0) 
	return new Word;
    else if (strcmp (i_elementname, "Paragraph") == 0)
	return new Paragraph;
    else if (strcmp (i_elementname, "Graphic") == 0)
	return new Graphic;
    else
	throw "autch. DocElementFactory : type not known yet...";
}

// end of file

