// main part -- custom
// $Id: main3.cpp,v 1.15 2001/10/10 07:03:20 ar Exp $
// 

/* Copyright (C) 2001 ATRSoft GmbH 
   This file is part of the ATRSoft GmbH utilitys.

   The ATRSoft GmbH utilitys is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or any later version.

   The ATRSoft GmbH utilitys is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the ATRSoft GmbH utilitys; see the file LICENSE.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

// http://www.atrsoft.de
// mailto: info@atrsoft.de

// visual c++ mfc add on. we dont need this if no afx app....
// for mfc apps you have to remove the double slashs 
// #include <stdafx.h>

// we use only factories. so we dont know anything about the real classes ...

#ifndef INCLUDED_DOCELEMENT_H
#    include "docelement.h"
#    undef INCLUDED_DOCELEMENT_H
#    define INCLUDED_DOCELEMENT_H
#endif


#ifndef INCLUDED_FACTORY_H
#    include "factory.h"
#    undef INCLUDED_FACTORY_H
#    define INCLUDED_FACTORY_H
#endif



#ifndef INCLUDED_VISITORFACTORY_H
#    include "visitorfactory.h"
#    undef INCLUDED_VISITORFACTORY_H
#    define INCLUDED_VISITORFACTORY_H
#endif



#ifndef INCLUDED_IOSTREAM
#    include <iostream>
#    undef INCLUDED_IOSTREAM
#    define INCLUDED_IOSTREAM
#endif



#ifndef INCLUDED_VECTOR
#    include <vector>
#    undef INCLUDED_VECTOR
#    define INCLUDED_VECTOR
#endif



#ifndef INCLUDED_MEMORY
#    include <memory>
#    undef INCLUDED_MEMORY
#    define INCLUDED_MEMORY
#endif



int 
main (int argc, char* argv[])
{
    using namespace std;

    try {
	vector<DocElement*> v;

	v.push_back (DocElementFactory("Word"));

	v.push_back (DocElementFactory("Paragraph"));

	v.push_back (DocElementFactory("Graphic"));

	auto_ptr<VoidVisitor> vis(Visitors ("MyVisitor1"));

	v[0]->accept (vis.get());
	v[1]->accept (vis.get());
	v[2]->accept (vis.get());

	// vis->show ();
    }
    catch (...)
    {
    }
    
    return 0;
}

// end of file

