// visitor urversion
// $Id: visitor.cpp,v 1.2 2001/08/16 13:29:58 ar Exp $
// 


#ifndef IOSTREAM
#    include <iostream>
#    undef IOSTREAM
#    define IOSTREAM
#endif


#ifndef VECTOR
#    include <vector>
#    undef VECTOR
#    define VECTOR
#endif


// bsp angelehnt an alexandrescu

class BaseVisitor;

class DocElement
{
private:

    int stuff_;

public:
    DocElement () 
	{
	    stuff_ = 42; // root of all evil
	}

    virtual ~DocElement ()
	{
	}

    virtual void accept (BaseVisitor&) = 0;

};

// DocElement nun ohne wissen ueber die abgeleiteten klassen
 
class Paragraph : public DocElement
{
    int pstuff_;

public:
    Paragraph () 
	{
	    pstuff_ = 43;
	}

    virtual ~Paragraph ()
	{
	}

    virtual void accept (BaseVisitor& v);

};

// Paragraph header nun ohne wissen von anderen klassen

class Word : public DocElement
{
    int wstuff_;

public:
    Word ()
	{
	    wstuff_ = 44;
	}
    
    virtual ~Word ()
	{
	}

    virtual void accept (BaseVisitor& v);
};

// word header nun ohne wissen von anderen klassen

class Word;

class Paragraph;

class BaseVisitor
{
public:
    virtual ~BaseVisitor ()
	{
	}

    virtual void visit (Word&) = 0;
    virtual void visit (Paragraph&) = 0;
};


class MyVisitor : public BaseVisitor
{
    int summ_;

public:
    
    MyVisitor () 
	{
	    summ_ = 0;
	}

    virtual ~MyVisitor ()
	{
	}

    virtual void visit (Word&);

    virtual void visit (Paragraph&);

    void show ();

};

// visitoren nun ohne wissen um die klassen. nur forward decl

void 
Paragraph::accept (BaseVisitor& v)
{
    v.visit (*this);
}

void 
Word::accept (BaseVisitor& v)
{
    v.visit (*this);
}

// impl von accept isoliert in je ein file. nur eigene klasse und base visitor


void 
MyVisitor::show ()
{
    std::cout << "summe ist " << summ_ << std::endl;
}

void MyVisitor::visit (Word&)
{
    summ_ += 1;
}

void MyVisitor::visit (Paragraph&)
{
    summ_ += 2;
}

// impls von visitoren in isolierten files. nur eigene klasse und visitorenklasse .

int main (int argc, char* argv[])
{

    std::vector<DocElement*> v;

    v.push_back (new Word);

    v.push_back (new Paragraph);

    
    MyVisitor vis;

    v[0]->accept (vis);
    v[1]->accept (vis);

    vis.show ();

    return 0;
}
