// visitor urversion
// $Id: visitor.gof.cpp,v 1.2 2001/08/16 13:29:58 ar Exp $
// 


#ifndef IOSTREAM
#    include <iostream>
#    undef IOSTREAM
#    define IOSTREAM
#endif


#ifndef VECTOR
#    include <vector>
#    undef VECTOR
#    define VECTOR
#endif


// bsp angelehnt an alexandrescu

class Word;

class Paragraph;


class BaseVisitor
{
public:
    virtual ~BaseVisitor ()
	{
	}

    virtual void visit (Word&) = 0;
    virtual void visit (Paragraph&) = 0;
};

class DocElement
{
private:

    int stuff_;

public:
    DocElement () 
	{
	    stuff_ = 42; // root of all evil
	}

    virtual ~DocElement ()
	{
	}

    virtual void accept (BaseVisitor&) = 0;

};


class Paragraph : public DocElement
{
    int pstuff_;

public:
    Paragraph () 
	{
	    pstuff_ = 43;
	}

    virtual ~Paragraph ()
	{
	}

    virtual void accept (BaseVisitor& v)
	{
	    v.visit (*this);
	}
};

class Word : public DocElement
{
    int wstuff_;

public:
    Word ()
	{
	    wstuff_ = 44;
	}
    
    virtual ~Word ()
	{
	}

    virtual void accept (BaseVisitor& v)
	{
	    v.visit (*this);
	}
};

class MyVisitor : public BaseVisitor
{
    int summ_;

public:
    
    MyVisitor () 
	{
	    summ_ = 0;
	}

    virtual ~MyVisitor ()
	{
	}

    virtual void visit (Word&)
	{
	    summ_ += 1;
	}

    virtual void visit (Paragraph&)
	{
	    summ_ += 2;
	}

    void show ();

};


void 
MyVisitor::show ()
{
    std::cout << "summe ist " << summ_ << std::endl;
}

int main (int argc, char* argv[])
{

    std::vector<DocElement*> v;

    v.push_back (new Word);

    v.push_back (new Paragraph);

    
    MyVisitor vis;

    v[0]->accept (vis);
    v[1]->accept (vis);

    vis.show ();

    return 0;
}
